<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<html><head><title>
Pico Device Manual: Interface command: 
</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="Content-Style-Type" content="text/css">
<link rel="stylesheet" title="Default" type="text/css" href="allegro.css"></head><body bgcolor=white text=black link="#0000ee" alink="#ff0000" vlink="#551a8b">
<h1><a name="Interface command: ">Interface command: </a></h1>

<ul>
<li><a href="#Ax">Ax</a> 
<li><a href="#Ax">Ax</a> 
<li><a href="#Connecting_your_PC_to_the_PicoTwist_device"> Connecting your PC to the PicoTwist device</a> 
<li><a href="#D__and_D_">D? and D=</a> 
<li><a href="#DAC16">DAC16</a> 
<li><a href="#echo">echo</a> 
<li><a href="#error">error</a> 
<li><a href="#flash">flash</a> 
<li><a href="#focus">focus</a> 
<li><a href="#ftran">ftran</a> 
<li><a href="#gbuf">gbuf</a> 
<li><a href="#grab">grab</a> 
<li><a href="#light">light</a> 
<li><a href="#nofoc">nofoc</a> 
<li><a href="#Px">Px</a> 
<li><a href="#R">R</a> 
<li><a href="#rhome">rhome</a> 
<li><a href="#rot">rot</a> 
<li><a href="#roti">roti</a> 
<li><a href="#rpid">rpid</a> 
<li><a href="#rtran">rtran</a> 
<li><a href="#T">T</a> 
<li><a href="#Toff">Toff</a> 
<li><a href="#tpid">tpid</a> 
<li><a href="#Typical_command"> Typical command</a> 
<li><a href="#zhome">zhome</a> 
<li><a href="#zmag">zmag</a> 
<li><a href="#zmagi">zmagi</a> 
<li><a href="#zori">zori</a> 
<li><a href="#zpid">zpid</a> 
<li><a href="#ztran">ztran</a> 
<li><a href="#zvcap">zvcap</a> 
</ul>


<p><br>
The magnetic tweezers apparatus is driven by a PC computer using
serial interface. The device contains USB to serial converter which
offen is more compatible with recent computers (having no more serial
interface). However, this USB to serial converter is seen by the
software as a new (virtual) serial interface (typically COM4 or
higher), thus we shall speak of serial interface even though it is
physically a USB interface. The USB inlet is located at the rear of
the apparatus opposite to the power input.


<p><br>
In normal operation the user just links the apparatus and PC using a
USB cable and launches the acquisition program specifying once the
serial port number in the config file and all the interaction between
the PC and the device is done in the acquisition program. If you want
to interface this device with another program, you will find here the
basic commands used to drives the device.



<p><br>
<div class="al-api"><b><a name="Connecting_your_PC_to_the_PicoTwist_device"> Connecting your PC to the PicoTwist device</a></b></div><br>



<p><br>
<img src="./pico-rs232-1.png" height="577" width="860" alt="Pico.exe start" align="center"> 


<p><br>
You can establish a connection with the device by using the
hyperterminal communication program under windows XP. Just open the
port associated with the device at 57600 bauds, 8 bits, no parity, one
stop bit and hardware handshaking.





<p><br>
<img src="./pico-rs232-2.png" height="583" width="860" alt="Pico.exe start" align="center"> 





<p><br>
<img src="./pico-rs232-3.png" height="583" width="862" alt="Pico.exe start" align="center"> 



<p><br>
<div class="al-api"><b><a name="Typical_command"> Typical command</a></b></div><br>




<p><br>
<img src="./pico-rs232-4.png" height="583" width="864" alt="Pico.exe start" align="center"> 



<p><br>
All command consist in a small ASCII sequence with optionally a
parameter followed either by an interrogation point to query a value
or an equal sign and the value to set. For instance, if you sent the
command "T0?" followed by a carriage return, the device will respond T0 =
25.456 to let you know the temperature of the sensor. We refer to this
command by T# since you can query the value of T0, T1, T2 and T4. To
specify the target temperature to 26 degrees, you will type R0=26 (with
no space and followed by a carriage return).

<p>
This is a list of the principal commands:


<p><br>
<div class="al-api"><b> <a name="T">T</a># </b></div><br>
        This command querries the temperature of various elements of the device. Temperatures are given in degrees Celcius.
<blockquote class="code"><pre>
      examples: 
        T0? (to read the sensor used for feedback) 
        T1? (to read the sample temperature) 
        T2? (to read the heat sink temperature) 
        T3? (to read the inductive sensor temperature) 
</pre></blockquote>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href=R#" title="">R#</a>,
<a class="xref" href=Toff#" title="">Toff#</a>.</blockquote>
<div class="al-api"><b> <a name="R">R</a># and R#= ;</b></div><br>
        This commands set the regulation temperature. Temperature is  given in degrees Celsius.
<blockquote class="code"><pre>
      examples: 
        R0? (to read the sensor used for feedback) 
        R0=26.34 (to set temperature to 26.34 degrees Celsius)  
</pre></blockquote>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href=T#" title="">T#</a>,
<a class="xref" href=Toff#" title="">Toff#</a>.</blockquote>
<div class="al-api"><b> <a name="Toff">Toff</a>#? and Toff#=k</b></div><br>




<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href=R#" title="">R#</a>,
<a class="xref" href=T#" title="">T#</a>.</blockquote>
<div class="al-api"><b> <a name="echo">echo</a>? and echo=</b></div><br>

<p>
        This command specify the communication behavior of the
device. If echo is set, all character sent will be echo to the
terminal (nice for human being), if echo is off no echo is done (nice
for interface). It also display the release date of the firmware.

<blockquote class="code"><pre>
      examples: "<a href="#echo" class="autotype" title="">echo</a>?" (to read <a href="#echo" class="autotype" title="">echo</a> status) "<a href="#echo" class="autotype" title="">echo</a> On 5/11/08"  (firmware 5th november 2008)
        <a href="#echo" class="autotype" title="">echo</a>=1 => set <a href="#echo" class="autotype" title="">echo</a> On
</pre></blockquote>

<p><br>
<div class="al-api"><b> <a name="focus">focus</a>? and focus=</b></div><br>

<p>
This commands the piezo position used to adjust the focus. This is the
normal command giving and receiving position in microns.

<blockquote class="code"><pre>
examples: <a href="#focus" class="autotype" title="">focus</a>? (to read position) <a href="#focus" class="autotype" title="">focus</a>=123.456 (to set <a href="#focus" class="autotype" title="">focus</a> at
123.456)
</pre></blockquote>

 

<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href=dac16" title="">dac16</a>,
<a class="xref" href="#nofoc" title="">nofoc</a>.</blockquote>
<div class="al-api"><b> <a name="DAC16">DAC16</a>? and Dac16=</b></div><br>

<p>
This is the binary version of the focus command, it drives the piezzo
position used to adjust focus. This command uses the 16bits integer
number as argument.

<blockquote class="code"><pre>
      examples: 
      dac16? (to read position) 
      dac16=32768 (to set <a href="#focus" class="autotype" title="">focus</a> at 125 microns) 
</pre></blockquote>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#focus" title="">focus</a>,
<a class="xref" href="#nofoc" title="">nofoc</a>.</blockquote>
<div class="al-api"><b> <a name="nofoc">nofoc</a>? and nofoc=</b></div><br>

<p>
This is an interface command that is used by the program to allow or
prevent focus adjustment by the user using the focus knob.

<blockquote class="code"><pre>
      examples: 
      <a href="#nofoc" class="autotype" title="">nofoc</a>? (to read position) 
      <a href="#nofoc" class="autotype" title="">nofoc</a>=0 (disable manual <a href="#focus" class="autotype" title="">focus</a>, 1 allow manual <a href="#focus" class="autotype" title="">focus</a>) 
</pre></blockquote>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#focus" title="">focus</a>,
<a class="xref" href=dac16" title="">dac16</a>.</blockquote>
<div class="al-api"><b> <a name="rot">rot</a>? and rot=</b></div><br>

<p>
This command queries and set the angular position of the magnets. The
units are turns.

<blockquote class="code"><pre>
      examples: 
        Rot? (to read the rotation position). 
            The answer will be: <a href="#rot" class="autotype" title="">rot</a> = xx.xxx turns if the motor has reach its target 
            The answer will be: <a href="#rot" class="autotype" title="">rot</a> = xx.xxx target yy.yyy if the motor is still running
            with xx.xxx the actual position
        ROT=25.5 (to set the rotation at 25.5 turns) 
            The answer will be: <a href="#rot" class="autotype" title="">rot</a> aiming 25.5
</pre></blockquote>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#roti" title="">roti</a>,
<a class="xref" href="#rhome" title="">rhome</a>.</blockquote>
<div class="al-api"><b> <a name="roti">roti</a>? and roti=</b></div><br>

<p>
This command queries and set the angular position of the magnets. The
units is encoder ticks (8000 per turn).

<blockquote class="code"><pre>
      examples: 
        Roti? (to read the rotation position). 
            The answer will be: <a href="#roti" class="autotype" title="">roti</a> = xxxxx turns if the motor has reach its target 
            The answer will be: <a href="#roti" class="autotype" title="">roti</a> = xxxxx target yyyyy if the motor is still running
            with xxxxx the actual position
        ROTI=zzzzzz (to set the rotation at zzzzz turns) 
            The answer will be: <a href="#roti" class="autotype" title="">roti</a> aiming zzzzz
</pre></blockquote>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#rot" title="">rot</a>,
<a class="xref" href="#rhome" title="">rhome</a>.</blockquote>
<div class="al-api"><b> <a name="rhome">rhome</a>? and rhome=</b></div><br>

<p>
This command allows to change the rotation reference position of the
magnets. The units is turn.

<blockquote class="code"><pre>
      examples: 
        Rhome=xx.xxx (to set the present rotation position to the value xx.xxx turns) 
            The answer will be : Rot home = xx.xxx
        Rhome? query the last home position
</pre></blockquote>




<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#rot" title="">rot</a>,
<a class="xref" href="#roti" title="">roti</a>.</blockquote>
<div class="al-api"><b> <a name="zmag">zmag</a>? and zmag=</b></div><br>

<p>
This command queries and set the vertical position of the magnets. The
units are millimetres.

<blockquote class="code"><pre>
      examples: 
        Zmag? (to read the present <a href="#zmag" class="autotype" title="">zmag</a> position). 
            The answer will be: Zmag = xx.xxx if the motor has reach its target 
            The answer will be: Zmag = xx.xxx target yy.yyy if the motor is still running
            with xx.xxx the actual position
        If the motor bumps in one of the translation limits, the answer will be preceded by
        Positive/Negative limit encountered
       Finally when the stage approach the bottom, the inductive sensor will warns that it is 
       approaching the limit and will display the voltage of the sensor if it is smaller than
       10V.
        Zmag=12.5 (to set the <a href="#zmag" class="autotype" title="">zmag</a> position at 12.5 mm) 
            The answer will be: Zmag aiming 12.5
</pre></blockquote>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#zmagi" title="">zmagi</a>,
<a class="xref" href="#zhome" title="">zhome</a>,
<a class="xref" href=zori#" title="">zori#</a>.</blockquote>
<div class="al-api"><b> <a name="zmagi">zmagi</a>? and zmagi=</b></div><br>
        This command querries and set the vertical position of the magnets. The units are ticks in motor units.
<blockquote class="code"><pre>
      examples: 
        Zmagi? (to read the present <a href="#zmag" class="autotype" title="">zmag</a> position). 
            The answer will be: Zmagi = xxxxx if the motor has reach its target 
            The answer will be: Zmagi = xxxxx target yyyyy if the motor is still running
            with xxxxx the actual position
        If the motor bumps in one of the translation limits, the answer will be preceeded by
        Positive/Negative limit encountered
       Finally when the stage approach the bottom, the inductive sensor will warns that it is 
       approaching the limit and will display the voltage of the sensor if it is smaller than
       10V.
        Zmag=42345 (to set the <a href="#zmag" class="autotype" title="">zmag</a> position at 42345) 
            The answer will be : Zmagi aiming 42345
</pre></blockquote>


<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#zmag" title="">zmag</a>,
<a class="xref" href="#zhome" title="">zhome</a>,
<a class="xref" href=zori#" title="">zori#</a>.</blockquote>
<div class="al-api"><b> <a name="zhome">zhome</a>? and zhome=</b></div><br>
        This command is used to change the reference point of zmag. 
<blockquote class="code"><pre>
      examples: 
        <a href="#zhome" class="autotype" title="">zhome</a>=2 specify that the present <a href="#zmag" class="autotype" title="">zmag</a> position is from now 2mm.
        <a href="#zhome" class="autotype" title="">zhome</a>? query the last reference position specified.
</pre></blockquote>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#zmag" title="">zmag</a>,
<a class="xref" href="#zmagi" title="">zmagi</a>,
<a class="xref" href=zori#" title="">zori#</a>.</blockquote>
<div class="al-api"><b> <a name="zori">zori</a>#? and zori#=</b></div><br>
        This command is used to set or query a new origin point
<blockquote class="code"><pre>
      examples:
        zori0=xx ask to the motor to move slowly to the top limit of the translation stage and once this position has been encountered to stop there and set the position as a reference to xx.
        zori1=yy same thing but with the bottom limit.
        zori0? ask the to the motor to move slowly to the top limit of the translation stage report the value of <a href="#zmag" class="autotype" title="">zmag</a> there and come back to the original value. This is used to check if the reference position as changed.
        zori1? same thing but with the bottom limit.
        zori2? ask the to the motor to move slowly to the limit switch of the translation stage located in the middle and report the value of <a href="#zmag" class="autotype" title="">zmag</a> there and come back to the original value. This is used to check if the reference position as changed.
</pre></blockquote>



<blockquote class="xref"><em><b>See also:</b></em>
<a class="xref" href="#zmag" title="">zmag</a>,
<a class="xref" href="#zmagi" title="">zmagi</a>,
<a class="xref" href="#zhome" title="">zhome</a>.</blockquote>
<div class="al-api"><b> <a name="zvcap">zvcap</a>? and zvcap=</b></div><br>
        This command is used to query or set the minimum value of the inductive sensor.
<blockquote class="code"><pre>
      examples: 
        <a href="#zvcap" class="autotype" title="">zvcap</a>=1.5 specifies that the motors cannot move if the signal of the inductive sensor become smaller than 1.5 volts.
        <a href="#zvcap" class="autotype" title="">zvcap</a>? queries the value of the minimum of the inductive sensor.
</pre></blockquote>


<p><br>
<div class="al-api"><b> <a name="light">light</a>? and light=</b></div><br>

<p>
This command is used to query or set the LED current level. The number
is a 12 bits integer value ranging from 0 -> 0mA to 4095 -> 700 mA.

<blockquote class="code"><pre>
      examples: 
        <a href="#light" class="autotype" title="">light</a>=2048 specify that the LED current is 700/2 mA
        <a href="#light" class="autotype" title="">light</a>? query the value of LED setting.
</pre></blockquote>


<p><br>
<div class="al-api"><b><a name="D__and_D_">D? and D=</a></b></div><br>



<p><br>
<div class="al-api"><b> <a name="Ax">Ax</a>?</b></div><br>

<p><br>
<div class="al-api"><b> <a name="Ax">Ax</a>? and Ax=</b></div><br>


<p><br>
<div class="al-api"><b> <a name="Px">Px</a>? and Px=</b></div><br>



<p><br>
<div class="al-api"><b> <a name="error">error</a>? and error=</b></div><br>



<p><br>
<div class="al-api"><b> <a name="ftran">ftran</a>? and ftran=</b></div><br>


<p><br>
<div class="al-api"><b> <a name="grab">grab</a>? and grab=</b></div><br>

<p><br>
<div class="al-api"><b> <a name="gbuf">gbuf</a>? and gbuf=</b></div><br>

<p><br>
<div class="al-api"><b> <a name="rpid">rpid</a>#? and rpid#=</b></div><br>

<p><br>
<div class="al-api"><b> <a name="zpid">zpid</a>#? and zpid#=</b></div><br>

<p><br>
<div class="al-api"><b> <a name="tpid">tpid</a>#? and tpid#=</b></div><br>

<p><br>
<div class="al-api"><b> <a name="ztran">ztran</a>? and ztran=</b></div><br>

<p><br>
<div class="al-api"><b> <a name="rtran">rtran</a>? and rtran=</b></div><br>

<p><br>
<div class="al-api"><b> <a name="flash">flash</a>? and flash=</b></div><br>


<p><br>
<hr><div class="al-back-to-contents"><a href="picodv.html">Back to contents</a></div>

</body>
</html>
